#!/bin/bash
#
#

#
# Remove files left from the previous run
#
echo "Removing autotools related files and directories ..."
rm -f  `find ./ -name "Makefile.in"`                 || exit 1
rm -f  config.cache aclocal.m4 config.h.in configure || exit 1
rm -f  config.guess config.sub ltmain.sh             || exit 1
rm -rf autom4te.cache                                || exit 1
rm -rf `find ./ -name ".deps"`                       || exit 1

echo "Build-tools versions:"
for tool in autoheader autoconf libtool libtoolize aclocal automake; do
  echo "---> `$tool --version | head -1`"
done

#####
##### Deprecated section
#####
#####echo "-----------------------------------------------------------------"
#####echo "ACLOCAL:"
#####aclocal --force --install -I m4
#####
#####echo "-----------------------------------------------------------------"
#####echo "AUTOHEADER:"
#####autoheader
#####
#####echo "-----------------------------------------------------------------"
#####echo "AUTOCONF:"
#####autoconf
#####
#####echo "-----------------------------------------------------------------"
#####echo "LIBTOOLIZE:"
#####libtoolize -c
#####
#####echo "-----------------------------------------------------------------"
#####echo "AUTOMAKE"
#####automake --gnu --add-missing --copy

echo "-----------------------------------------------------------------"
autoreconf --verbose --force --install &&
./configure --prefix=`pwd`/../../build \
    --localstatedir=`pwd`/../../build/var \
    --with-idl-path=`pwd`/../g2mpls_idl || exit 1
