#!/bin/bash
#
#   This file is part of phosphorus-g2mpls.
#
#   Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License along
#   with this program; if not, write to the Free Software Foundation, Inc.,
#   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
#   Authors:
#
#   Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
#   Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
#   Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
#   Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
#   Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
#



#
# Remove files left from the previous run
#
echo "Removing autotools related files and directories ..."
rm -f  `find ./ -name "Makefile.in"`                 || exit 1
rm -f  config.cache aclocal.m4 config.h.in configure || exit 1
rm -f  config.guess config.sub ltmain.sh             || exit 1
rm -rf autom4te.cache                                || exit 1
rm -rf `find ./ -name ".deps"`                       || exit 1

echo "Build-tools versions:"
for tool in autoheader autoconf libtool libtoolize aclocal automake; do
  echo "---> `$tool --version | head -1`"
done

#####
##### Deprecated section
#####
#####echo "-----------------------------------------------------------------"
#####echo "ACLOCAL:"
#####aclocal --force --install -I m4
#####
#####echo "-----------------------------------------------------------------"
#####echo "AUTOHEADER:"
#####autoheader
#####
#####echo "-----------------------------------------------------------------"
#####echo "AUTOCONF:"
#####autoconf
#####
#####echo "-----------------------------------------------------------------"
#####echo "LIBTOOLIZE:"
#####libtoolize -c
#####
#####echo "-----------------------------------------------------------------"
#####echo "AUTOMAKE"
#####automake --gnu --add-missing --copy

echo "-----------------------------------------------------------------"
autoreconf --verbose --force --install &&
./configure --enable-vtysh --disable-ipv6 --disable-bgpd \
    --disable-ripd --disable-ripngd --disable-ospf6d \
    --disable-bgp-announce --enable-opaque-lsa \
    --enable-ospf-te --disable-rtadv --enable-tcp-zebra \
    --disable-capabilities --disable-xxxd \
    --disable-watchquagga --disable-snmp \
    --prefix=`pwd`/../../build \
    --localstatedir=`pwd`/../../build/var \
    --with-idl-path=`pwd`/../g2mpls_idl \
    --with-libg2mpls-path=`pwd`/../g2mpls_common \
    --with-run-user=$USER \
    --with-run-group=users || exit 1

