//
//  This file is part of phosphorus-g2mpls.
//
//  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//  Authors:
//
//  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
//  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
//  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
//  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
//  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
//


#ifndef __G2PCERA_VTY_UTILS_HH__
#define __G2PCERA_VTY_UTILS_HH__

#include "g2mpls_types.h"
#include "g2mpls_utils.h"

typedef struct call_data {
	call_ident_t		cid;
	call_info_t		cdata;
	recovery_info_t		rdata;
	lsp_info_t		ldata;
} call_data_t;

//
//
//  GNS CALL container
//
//
#define BAR1 "========================================"	\
	     "========================================"
#define BAR2 "----------------------------------------"	\
	     "----------------------------------------"
#define SHOWLIST_DEPTH 50


typedef uint64_t mapKey_t;	// local_id


bool			vtyCallRoutable(const mapKey_t &	callKey);

void			vtyCallDump(struct vty *		vty);

void			vtyCallDump(struct vty *		vty,
				    const mapKey_t &		callKey);

bool			vtyCallUpdate(const mapKey_t &		callKey,
				      const g2mpls_addr_t &	lsr,
				      const uint32_t &		ituCountryCode,
				      const uint64_t &		ituCarrierCode,
				      const uint64_t &		uniqueAP,
				      std::string &		err);

bool			vtyCallUpdate(const mapKey_t &		callKey,
				      const call_info_t &	cinfo,
				      std::string &		err);

bool			vtyCallUpdate(const mapKey_t &		callKey,
				      const recovery_info_t &	rinfo,
				      std::string &		err);

bool			vtyCallUpdate(const mapKey_t &		callKey,
				      const lsp_info_t &	linfo,
				      std::string &		err);

bool			vtyCallRoute(uint32_t			g2pceraId,
				     const mapKey_t &		callKey,
				     std::list<ero_hop_t> &	ero,
				     net_res_spec_t &		eTna,
				     std::string &		err);

bool			vtyCallFlush(uint32_t			g2pceraId,
				     const mapKey_t &		callKey,
				     std::string &		err);

bool			vtyCallConfirm(uint32_t			g2pceraId,
				       const mapKey_t &		callKey,
				       std::string &		err);
bool			vtyGetConnections(uint32_t		 g2pceraId,
					  const mapKey_t &	 callKey,
					  std::list<ero_hop_t> & pEro,
					  std::list<ero_hop_t> & sEro,
					  std::string &		 err);

bool			defaultGridResSpec(res_spec_t &		res);

#endif // __G2PCERA_VTY_UTILS_HH__
