/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#ifndef _G2RSVPTE_CORBA_H_
#define _G2RSVPTE_CORBA_H_

#if HAVE_OMNIORB

#include "lib/corba.h"
#include "idl/lrm.hh"
#include "idl/tnrc.hh"
#include "idl/RecoveryController.hh"
#include "idl/CallController.hh"
#include "idl/PersistencyController.hh"
#include "idl/g2pcera.hh"
#include <iostream>

extern LRM::Info_var                                 lrm_proxy;
extern TNRC::NorthBound_var                          tnrc_proxy;
extern RecoveryController::SouthBound_var            rc_proxy;
extern CallController::LspSigSouth_var               cc_ls_proxy;
extern CallController::Mgmt_var                      cc_mgmt_proxy;
extern PersistencyController::StorageMgmt_var        pc_mgmt_proxy;
extern PersistencyController::StorageInniRsvpLsp_var pc_innirsvplsp_proxy;
extern PersistencyController::StorageUniRsvpLsp_var  pc_unirsvplsp_proxy;
extern PersistencyController::StorageEnniRsvpLsp_var pc_ennirsvplsp_proxy;
extern G2PCERA::RoutingServices_var                  g2pcera_proxy;

int  corba_server_setup(void);
int  tnrc_server_setup(void);
int  nb_server_setup(void);
int  unirsvp_lspsignorth_server_setup(void);
int  ennirsvp_lspsignorth_server_setup(void);
int  corba_server_shutdown(void);
int  tnrc_server_shutdown(void);
int  nb_server_shutdown(void);
int  unirsvp_lspsignorth_server_shutdown(void);
int  ennirsvp_lspsignorth_server_shutdown(void);
bool corba_client_setup(LRM::Info_var & l);
bool corba_client_setup(TNRC::NorthBound_var & t);
bool corba_client_setup(RecoveryController::SouthBound_var & rc);
bool corba_client_setup(CallController::LspSigSouth_var & cc, bool isClient = false);
bool corba_client_setup(CallController::Mgmt_var & cc, bool isClient = false);
bool corba_client_setup(PersistencyController::StorageMgmt_var & pc);
bool corba_client_setup(PersistencyController::StorageInniRsvpLsp_var & pc);
bool corba_client_setup(PersistencyController::StorageUniRsvpLsp_var & pc);
bool corba_client_setup(PersistencyController::StorageEnniRsvpLsp_var & pc);
bool corba_client_setup(G2PCERA::RoutingServices_var & g2pcera);
bool corba_client_shutdown(corba_servant_t s);

// Utils

#endif // HAVE_OMNIORB

#endif
