/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#ifndef __G2RSVPTE_TNRC_APIS_H__
#define __G2RSVPTE_TNRC_APIS_H__

#include "g2mpls_types.h"
#include "g2mpls_addr.h"

#include "g2rsvpted/g2rsvpte_dm.h"

// return true if label is found
bool check_label(g2mpls_addr_t   localDL,
		 uint32_t        label,
		 label_state_t & labelStatus,
		 opstate_t &     operStatus);

// return true if the resource setting has been done
bool setResource(RSVP::LSP * lsp, bool isVirtual = false);

// return true if the resource releasing has been done
bool releaseResource(RSVP::LSP * lsp);

#endif // __G2RSVPTE_TNRC_APIS_H__
