//
//  This file is part of phosphorus-g2mpls.
//
//  Copyright (C) 2006, 2007, 2008, 2009 University of Essex.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//  Authors:
//
//  Eduard Escalona       (Univ. of Essex)   <eescal_at_essex.ac.uk>
//



#include "soapGridResourceRegistryBindingProxy.h"
#include "GridResourceRegistryBinding.nsmap"
#include "soapH.h"
#include "soapStub.h"

const char server[] = "localhost:8888";
//const char server[] = "http://packcs-e0.scai.fraunhofer.de/phosphorus-wp2/services/GridResourceRegistryService";

int
main ()
{
    GridResourceRegistryBindingProxy GRR;
    
    glue__SiteType *PO = new glue__SiteType;
    grr2__BoolType *POR = new grr2__BoolType;
    
    PO->Name = new char;
    PO->UniqueID = new char;
    PO->Cluster = new glue__ClusterType*;
    PO->Cluster[0] = new glue__ClusterType;
    PO->Cluster[0]->UniqueID = new char;
    PO->Cluster[0]->ComputingElement = new glue__ComputingElementType*;
    PO->Cluster[0]->ComputingElement[0] = new glue__ComputingElementType;
    PO->Cluster[0]->ComputingElement[0]->UniqueID = new char;
    PO->Cluster[0]->ComputingElement[0]->GRAMVersion = new char;
    PO->Cluster[0]->ComputingElement[0]->HostName = new char;
    PO->Cluster[0]->ComputingElement[0]->GateKeeperPort = new char;
    PO->Cluster[0]->ComputingElement[0]->FreeJobSlots = new char;
    PO->Cluster[0]->SubCluster = new glue__SubClusterType*;
    PO->Cluster[0]->SubCluster[0] = new glue__SubClusterType;
    PO->Cluster[0]->SubCluster[0]->UniqueID = new char;
    PO->Cluster[0]->SubCluster[0]->PhysicalCPUs = new char;
    
    PO->Name = "SITE_EDU2";
    PO->UniqueID = "1";
    PO->__sizeCluster = 1;
    PO->Cluster[0]->UniqueID = "11";
    PO->Cluster[0]->__sizeComputingElement = 1;
    PO->Cluster[0]->ComputingElement[0]->UniqueID = "111";
    PO->Cluster[0]->ComputingElement[0]->GRAMVersion = "UNICORE6";
    PO->Cluster[0]->ComputingElement[0]->HostName = "packcs-e0.scai.fraunhofer.de";
    PO->Cluster[0]->ComputingElement[0]->GateKeeperPort = "443";
    PO->Cluster[0]->ComputingElement[0]->FreeJobSlots = "10";
    PO->Cluster[0]->__sizeSubCluster = 1;
    PO->Cluster[0]->SubCluster[0]->UniqueID = "112";
    PO->Cluster[0]->SubCluster[0]->PhysicalCPUs = "10";
    
    GRR.soap_endpoint = server;
    GRR.publishOperation(PO, POR);
    
    if (POR->boolean == true)
        printf("TRUE\n");
    else
        printf("FALSE\n");

    delete PO->Cluster[0]->SubCluster[0];
    delete PO->Cluster[0]->SubCluster;
    delete PO->Cluster[0]->ComputingElement[0];
    delete PO->Cluster[0]->ComputingElement;
    delete PO->Cluster[0];
    delete PO->Cluster;
    delete POR;
    delete PO;
    
    return 0;
}
