//
//  This file is part of phosphorus-g2mpls.
//
//  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
//  Copyright (C) 2006, 2007, 2008, 2009 University of Essex.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//  Authors:
//
//  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
//  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
//  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
//  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
//  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
//  Eduard Escalona       (Univ. of Essex)   <eescal_at_essex.ac.uk>
//



#ifndef _GUNIGW_CORBA_H_
#define _GUNIGW_CORBA_H_

#include "lib/corba.h"
#include "g2mpls_corba_utils.h"
#include "../idl/types.hh"
#include "../idl/g2mplsTypes.hh"
#include "../idl/CallController.hh"
#include "../idl/g2mplsTopology.hh"
#include "../idl/lrm.hh"

#include "soapBESFactoryBindingProxy.h"

#include <iostream>

#include "gunigw_config.hh"
#include "gunigw_utils.hh"

#if HAVE_OMNIORB

bool    corba_server_setup(void);
bool    corba_server_shutdown(void);

bool	corba_client_setup(CallController::Mgmt_var & l);
bool    corba_client_setup(CallController::EastWest_var & l);
bool	corba_client_setup(g2mplsTopology::Info_var & l);
bool	corba_client_setup(LRM::Info_var & l);
bool	corba_client_shutdown(corba_servant_t s);

int	sendSetupIndication(struct thread*);
int	sendSetupConfirm(struct thread*);
int	sendReleaseIndication(struct thread*);
int	sendCallSetGnsTna(struct thread*);
#endif // HAVE_OMNIORB

#endif
