/* soapGridResourceRegistryBindingService.h
   Generated by gSOAP 2.7.11 from gunigw_ws.hpp
   Copyright(C) 2000-2008, Robert van Engelen, Genivia Inc. All Rights Reserved.
   This part of the software is released under one of the following licenses:
   GPL, the gSOAP public license, or Genivia's license for commercial use.
*/

#ifndef soapGridResourceRegistryBindingService_H
#define soapGridResourceRegistryBindingService_H
#include "soapH.h"
class SOAP_CMAC GridResourceRegistryBindingService : public soap
{ public:
	/// Constructor
	GridResourceRegistryBindingService();
	/// Constructor with copy of another engine state
	GridResourceRegistryBindingService(const struct soap&);
	/// Constructor with engine input+output mode control
	GridResourceRegistryBindingService(soap_mode iomode);
	/// Constructor with engine input and output mode control
	GridResourceRegistryBindingService(soap_mode imode, soap_mode omode);
	/// Destructor frees all data
	virtual ~GridResourceRegistryBindingService();
	/// Initializer used by constructor
	virtual	void GridResourceRegistryBindingService_init(soap_mode imode, soap_mode omode);
	/// Create a copy
	virtual	GridResourceRegistryBindingService *copy();
	/// Force close connection (normally automatic)
	virtual	int soap_close_socket();
	/// Return sender-related fault to sender
	virtual	int soap_senderfault(const char *string, const char *detailXML);
	/// Return sender-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_senderfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Return receiver-related fault to sender
	virtual	int soap_receiverfault(const char *string, const char *detailXML);
	/// Return receiver-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_receiverfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Print fault
	virtual	void soap_print_fault(FILE*);
#ifndef WITH_LEAN
	/// Print fault to stream
	virtual	void soap_stream_fault(std::ostream&);
	/// Put fault into buffer
	virtual	char *soap_sprint_fault(char *buf, size_t len);
#endif
	/// Disables and removes SOAP Header from message
	virtual	void soap_noheader();
	/// Run simple single-thread iterative service on port until a connection error occurs (returns error code or SOAP_OK), use this->bind_flag = SO_REUSEADDR to rebind for a rerun
	virtual	int run(int port);
	/// Bind service to port (returns master socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET bind(const char *host, int port, int backlog);
	/// Accept next request (returns socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET accept();
	/// Serve this request (returns error code or SOAP_OK)
	virtual	int serve();
	/// Used by serve() to dispatch a request (returns error code or SOAP_OK)
	virtual	int dispatch();

	///
	/// Service operations (you should define these):
	///

	/// Web service operation 'publishOperation' (returns error code or SOAP_OK)
	virtual	int publishOperation(glue__SiteType *glue__Site, grr2__BoolType *grr2__Bool);

	/// Web service operation 'getResourcesOperation' (returns error code or SOAP_OK)
	virtual	int getResourcesOperation(grr2__SiteDocumentArrayType *grr2__SiteDocumentArray);
};
#endif
