/* soapnetworkReservationBindingService.h
   Generated by gSOAP 2.7.11 from Reservation-WS.h
   Copyright(C) 2000-2008, Robert van Engelen, Genivia Inc. All Rights Reserved.
   This part of the software is released under one of the following licenses:
   GPL, the gSOAP public license, or Genivia's license for commercial use.
*/

#ifndef soapnetworkReservationBindingService_H
#define soapnetworkReservationBindingService_H
#include "soapH.h"
class SOAP_CMAC networkReservationBindingService : public soap
{ public:
	/// Constructor
	networkReservationBindingService();
	/// Constructor with copy of another engine state
	networkReservationBindingService(const struct soap&);
	/// Constructor with engine input+output mode control
	networkReservationBindingService(soap_mode iomode);
	/// Constructor with engine input and output mode control
	networkReservationBindingService(soap_mode imode, soap_mode omode);
	/// Destructor frees all data
	virtual ~networkReservationBindingService();
	/// Initializer used by constructor
	virtual	void networkReservationBindingService_init(soap_mode imode, soap_mode omode);
	/// Create a copy
	virtual	networkReservationBindingService *copy();
	/// Force close connection (normally automatic)
	virtual	int soap_close_socket();
	/// Return sender-related fault to sender
	virtual	int soap_senderfault(const char *string, const char *detailXML);
	/// Return sender-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_senderfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Return receiver-related fault to sender
	virtual	int soap_receiverfault(const char *string, const char *detailXML);
	/// Return receiver-related fault with SOAP 1.2 subcode to sender
	virtual	int soap_receiverfault(const char *subcodeQName, const char *string, const char *detailXML);
	/// Print fault
	virtual	void soap_print_fault(FILE*);
#ifndef WITH_LEAN
	/// Print fault to stream
	virtual	void soap_stream_fault(std::ostream&);
	/// Put fault into buffer
	virtual	char *soap_sprint_fault(char *buf, size_t len);
#endif
	/// Disables and removes SOAP Header from message
	virtual	void soap_noheader();
	/// Run simple single-thread iterative service on port until a connection error occurs (returns error code or SOAP_OK), use this->bind_flag = SO_REUSEADDR to rebind for a rerun
	virtual	int run(int port);
	/// Bind service to port (returns master socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET bind(const char *host, int port, int backlog);
	/// Accept next request (returns socket or SOAP_INVALID_SOCKET)
	virtual	SOAP_SOCKET accept();
	/// Serve this request (returns error code or SOAP_OK)
	virtual	int serve();
	/// Used by serve() to dispatch a request (returns error code or SOAP_OK)
	virtual	int dispatch();

	///
	/// Service operations (you should define these):
	///

	/// Web service operation 'isAvailable' (returns error code or SOAP_OK)
	virtual	int isAvailable(_rsv__isAvailable *rsv__isAvailable, _rsv__isAvailableResponse *rsv__isAvailableResponse);

	/// Web service operation 'createReservation' (returns error code or SOAP_OK)
	virtual	int createReservation(_rsv__createReservation *rsv__createReservation, _rsv__createReservationResponse *rsv__createReservationResponse);

	/// Web service operation 'getReservation' (returns error code or SOAP_OK)
	virtual	int getReservation(_rsv__getReservation *rsv__getReservation, _rsv__getReservationResponse *rsv__getReservationResponse);

	/// Web service operation 'getReservations' (returns error code or SOAP_OK)
	virtual	int getReservations(_rsv__getReservations *rsv__getReservations, _rsv__getReservationsResponse *rsv__getReservationsResponse);

	/// Web service operation 'getStatus' (returns error code or SOAP_OK)
	virtual	int getStatus(_rsv__getStatus *rsv__getStatus, _rsv__getStatusResponse *rsv__getStatusResponse);

	/// Web service operation 'cancelReservation' (returns error code or SOAP_OK)
	virtual	int cancelReservation(_rsv__cancelReservation *rsv__cancelReservation, _rsv__cancelReservationResponse *rsv__cancelReservationResponse);

	/// Web service operation 'completeJob' (returns error code or SOAP_OK)
	virtual	int completeJob(_rsv__completeJob *rsv__completeJob, _rsv__completeJobResponse *rsv__completeJobResponse);

	/// Web service operation 'cancelJob' (returns error code or SOAP_OK)
	virtual	int cancelJob(_rsv__cancelJob *rsv__cancelJob, _rsv__cancelJobResponse *rsv__cancelJobResponse);

	/// Web service operation 'activate' (returns error code or SOAP_OK)
	virtual	int activate(_rsv__activate *rsv__activate, _rsv__activateResponse *rsv__activateResponse);

	/// Web service operation 'bind' (returns error code or SOAP_OK)
	virtual	int bind(_rsv__bind *rsv__bind, _rsv__bindResponse *rsv__bindResponse);

	/// Web service operation 'notification' (returns error code or SOAP_OK)
	virtual	int notification(_rsv__notification *rsv__notification, _rsv__notificationResponse *rsv__notificationResponse);
};
#endif
