/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#ifndef _LRM_CORBA_H_
#define _LRM_CORBA_H_

#include "lrmd.h"

#ifdef __cplusplus
extern "C" {
#endif

int corba_server_setup(void);
int corba_server_shutdown(void);

int corba_scngw_client_setup(void);
int corba_tnrc_client_setup(void);
int corba_scngw_client_shutdown(void);
int corba_tnrc_client_shutdown(void);
int corba_lrm_isup(void);

int scngw_scnif_add(ctrl_intf_t * scnif);
int scngw_scnif_delete(ctrl_intf_t * scnif);
int scngw_cc_scnif_assoc_add(cc_t * cc);
int scngw_cc_scnif_assoc_delete(cc_t * cc);
int scngw_tel_cc_assoc_add(te_link_t * tel);
int scngw_tel_cc_assoc_delete(te_link_t * tel);
int scngw_tel_cc_assoc_update(te_link_t * tel, int op, u_int32_t cc_id);

int tnrc_get_dlink_details(datalink_t * dl);

#ifdef __cplusplus
}
#endif

#endif
