
import sys
import omniORB
from omniORB import CORBA

sys.path.insert(0, '/home/user01/phosphorus-g2mpls/src/pyg2mpls/corbasket')
#sys.path.insert(0, 'lrm_corbasket')
import LRM.LRM as LRM
sys.path.pop(0)

addresses = [
    '192.168.100.8',
    '192.168.100.9',
    '192.168.100.10',
    '192.168.100.11',
    '192.168.100.137',
    '192.168.100.138',
    '192.168.100.139',
]


def itoa(ia):
  '''convert long int to dotted ip address string'''
  r = ia>>24, (ia&0xFF0000)>>16, (ia&0xFF00)>>8, ia&0xFF
  return '.'.join([str(s) for s in r])


def read_link_statuses(ip_addr):
    print '\nGetting links statuses from lrm in %s' % ip_addr

    orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)
    iorfile = '/mnt/g2iors/node-%s/lrm.ior' % ip_addr
    ior = file(iorfile, 'r').readline()
    print "ior is", ior

    obj = orb.string_to_object(ior)
    lrm = obj._narrow(LRM.Info)
    print 'lrm is', lrm
    if lrm is None:
      print "Object reference is not an LRM::Info"
      return ''
    
    raw_text = ""
    print 'getting telink list'
    link_list = lrm.allTELinkIds()
    print 'iterating over', link_list
    for linkid in link_list:
        print "TE-Link link id is %s (%s)" % (str(linkid), itoa(linkid._v))
        linkid_ipv4 = itoa(linkid._v)
        _,oper,adm = lrm.getTELinkStatus(linkid)
        raw_text += "%s %s %s %s\n" % (ip_addr, linkid_ipv4, oper, adm)
        
    return raw_text


def get_link_statuses():
    raw_text = ""
    for addr in addresses:
        try:
            raw_text += read_link_statuses(addr)
        except Exception, e:
            import traceback
            traceback.print_exc()
    return raw_text

def send_link_statuses(addr, raw_text):
    import httplib, urllib
    params = urllib.urlencode({'telinks': raw_text})
    headers = {"Content-type": "application/x-www-form-urlencoded",
            "Accept": "text/plain"}
    conn = httplib.HTTPConnection("%s:80" % addr)
    conn.request("POST", "/testbed/phosphorus_testbed/fff/test3.php", params, headers)
    response = conn.getresponse()
    data = response.read()
    #print 'http response is', response, data
    conn.close()


if __name__ == '__main__':
    import time
    omniORB.setClientCallTimeout(500)
    while True:
    	text = get_link_statuses()
        try:
            pass
    	    #send_link_statuses('150.254.171.133', text)
        except:
            pass
        time.sleep(3)
