import sys
from omniORB import CORBA

sys.path.insert(0, '/home/quagga/phosphorus-g2mpls/d2.10/pyg2mpls/corbasket')
import G2PCERA._GlobalIDL as glob
import G2PCERA.G2PCERA as g2pcera
sys.path.pop(0)

def itoa(ia):
  '''convert long int to dotted ip address string'''
  r = ia>>24, (ia&0xFF0000)>>16, (ia&0xFF00)>>8, ia&0xFF
  return '.'.join([str(s) for s in r])


def pce_test():
    
    orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)
    iorfile = '/home/quagga/phosphorus-g2mpls/d2.10/build/var/g2pcera.ior'
    ior = file(iorfile, 'r').readline()
    print "ior is", ior

    obj = orb.string_to_object(ior)
    pce = obj._narrow(g2pcera.RoutingServices)
    if pce is None:
      print "Object reference is not an g2pcera::RoutingServices"
      sys.exit(1)

    
    callID = glob.g2mplsTypes.callIdent(
                    idType =                glob.g2mplsTypes.CALLIDTYPE_NULL, 
                    srcId =                 glob.g2mplsTypes.sourceId(ipv4 = 0x0a0a0a01),
                    localId =               568)


    callInfo = glob.g2mplsTypes.callParams(
                    name =                  'ipv4#10.10.10.12', 
                    type =                  glob.g2mplsTypes.CALLTYPE_AUTO,
                    times =                 glob.g2mplsTypes.timeInfo(0,1),
                    jobName =               'GridFTP transfer',
                    jobProject =            '')
    
    recoveryInfo = glob.g2mplsTypes.recoveryParams(
                    recType =               glob.g2mplsTypes.RECOVERYTYPE_UNPROTECTED,                        
                    disjType =              glob.g2mplsTypes.DISJOINTNESS_NONE)
    
    lspInfo = glob.g2mplsTypes.lspParams(
                    type              =               glob.g2mplsTypes.LSPTYPE_SPC,
                    role              =               glob.g2mplsTypes.LSPROLE_UNDEFINED,
                    swCap             =               glob.g2mplsTypes.SWITCHINGCAP_LSC,
                    encType           =               glob.g2mplsTypes.ENCODINGTYPE_LAMBDA,
                    gpid              =               glob.g2mplsTypes.GPID_LAMBDA,
                    bw                =                1000000,
                    setupPrio         =                0,
                    holdingPrio       =                0,
            excludeAny        =                0,
            includeAny        =                0,
            includeAll        =                0,
                    linkProtMask      =               glob.g2mplsTypes.PROTTYPE_NONE,
                    crankback         =               glob.g2mplsTypes.CRANCKBACKSCOPE_NONE,
            maxCbackRetriesSrc   =                0,
            maxCbackRetriesIntmd =                0,
                    action            =               glob.g2mplsTypes.LSPRESOURCEACTION_XCONNECT,
                    rroMode           =               glob.g2mplsTypes.LSPRROMODE_OFF,
            refreshInterval   =                0,
            activateAck       =                0,
            rapidRetransmInterval =            0,
            rapidRetryLimit   =                0,
            incrementValueDelta =              0,
            times             =                glob.g2mplsTypes.timeInfo(0,1) )		       
               
    aaaInfo = glob.g2mplsTypes.aaaParams(authzToken = '')
    
    actor = glob.g2mplsTypes.actorInfo(
                    issuer            = glob.g2mplsTypes.ISSUERTYPE_MANAGEMENT_IF,
                    forceCommand    = True)


    pos_ingress = glob.g2mplsTypes.RESOURCEPOSITION_INGRESS
    pos_egress  = glob.g2mplsTypes.RESOURCEPOSITION_EGRESS
    
    
    tnaRes_ingress = glob.g2mplsTypes.tnaResource(
                    tna      = glob.g2mplsTypes.tnaId(ipv4 = 0xa0a0a01),
                    dataLink = glob.g2mplsTypes.linkId(ipv4 = 0),
                    label    = glob.g2mplsTypes.labelId(label32 = 0)) 


    tnaRes_egress = glob.g2mplsTypes.tnaResource(
                    tna      = glob.g2mplsTypes.tnaId(ipv4 =0x5a5a5a01),
                    dataLink = glob.g2mplsTypes.linkId(ipv4 = 0),
                    label    = glob.g2mplsTypes.labelId(label32 = 0)) 
    
    
    src_endpoint = glob.g2mplsTypes.connEndPoint(
                   node     = 0xc0a86489,
		   teLink   = glob.g2mplsTypes.TELinkId(ipv4 = 0),
		   dataLink = glob.g2mplsTypes.DLinkId(ipv4 = 0),
		   label    = glob.g2mplsTypes.labelId(label32 = 0))
    
    
    dst_endpoint = glob.g2mplsTypes.connEndPoint(
                   node     = 0xc0a8648b,
		   teLink   = glob.g2mplsTypes.TELinkId(ipv4 = 0),
		   dataLink = glob.g2mplsTypes.DLinkId(ipv4 = 0),
		   label    = glob.g2mplsTypes.labelId(label32 = 0))
    
    tna = glob.g2mplsTypes.tnaId(ipv4 = 0x5a5a5a01)
    
    node1 = pce.nodeGetFromTnaRes(tnaRes_ingress)
    node2 = pce.nodeGetFromTna(tna)
    
    print
    print "nodeGetFromTna %s (%s)" % (node2 ,itoa(node2))
    print "nodeGetFromTnaRes %s (%s)" % (node1, itoa(node1[1]))
    
    #telink = glob.g2mplsTypes.linkId(ipv4 = 0x06090101)
    #print
    
    #node3 = pce.nodeGetFromTELink(telink)
    
    #print node3, " - nodeGetFromTELink: "
    #for k in node3[1:]:
    #    print "\t * %s" % itoa(k)
    #print
    
    print "Call Route  "
    call_ero = pce.callRoute(tnaRes_ingress,tnaRes_egress,callID,callInfo,recoveryInfo,lspInfo)
    print "CallRoute returned call ero: ", call_ero  

    for e in call_ero[1]:
    	print "\t * %s" % (str((itoa(e.node), itoa(e.teLink.ipv4), itoa(e.upstreamDataLink.ipv4), hex(e.upstreamLabel.label32))))
	
    #print pce.callConfirm(id)
    #print pce.callFlush(id)
    
    print "Connection Route"
    eros = pce.connectionRoute(src_endpoint,dst_endpoint,callID,lspInfo,[])
    print "ConnectionRoute returned lsp ero:", eros[1]
    
    for e in eros[1]:
        print "\t * %s" % (str((itoa(e.node), itoa(e.teLink.ipv4), itoa(e.upstreamDataLink.ipv4), hex(e.upstreamLabel.label32))))

if __name__ == '__main__':
    pce_test()
    print " End "