# -*- coding: utf-8 -*-
import os, signal, sys
import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade

import time
import threading
from popen2 import popen3
import re
import httplib

visible_console = False

SERVER = { '192.168.150.115': '10.0.1.1',
           '192.168.153.12' : '10.0.1.2',
           '192.168.153.13' : '10.0.1.3',
	   '192.168.153.14' : '10.0.1.3'}

#=========================================================================

class DDSS_backup:
    def __init__(self, filename, filesize):
        self.filename = filename
        self.filesize = filesize
        self.terminated = False
        self.step = 0.0
        self.gladefile = "popup4.glade"
        self.wTree = gtk.glade.XML(self.gladefile)
        self.window = self.wTree.get_widget("MainWindow")
        if (self.window):
            self.window.connect("destroy", gtk.main_quit)

        self.fixed = self.wTree.get_widget("fixed1")
        self.buttonCancel = self.wTree.get_widget("buttonCancel")
        self.buttonShowTopology = self.wTree.get_widget("buttonShowTopology")
        self.labelFilename = self.wTree.get_widget("labelFilename")
        self.labelFileName = self.wTree.get_widget("label1")
        self.labelFileName.set_justify(gtk.JUSTIFY_LEFT)
        self.progressbar = self.wTree.get_widget("progressbar1")
        self.labelDDSS = self.wTree.get_widget("label1")
        self.statusbar = self.wTree.get_widget("statusbar")
        self.context_id = self.statusbar.get_context_id('filename')
        self.message_id = self.statusbar.push(self.context_id, "file: "+self.filename)

        self.labelStatus1 = self.wTree.get_widget("labelStat1")
        self.labelStatus2 = self.wTree.get_widget("labelStat2")
        self.labelStatus3 = self.wTree.get_widget("labelStat3")
        self.labelStatus4 = self.wTree.get_widget("labelStat4")
        self.labelStatus5 = self.wTree.get_widget("labelStat5")
        self.labelStatus6 = self.wTree.get_widget("labelStat6")
        self.labelStatus7 = self.wTree.get_widget("labelStat7")
        self.labelStatus8 = self.wTree.get_widget("labelStat8")
        self.labelStatus9 = self.wTree.get_widget("labelStat9")
 
        try:
            self.ok1 = self.wTree.get_widget("ok1")
            self.ok2 = self.wTree.get_widget("ok2")
            self.ok3 = self.wTree.get_widget("ok3")
            self.ok4 = self.wTree.get_widget("ok4")
            self.ok5 = self.wTree.get_widget("ok5")
            self.ok6 = self.wTree.get_widget("ok6")
            self.ok7 = self.wTree.get_widget("ok7")
            self.ok8 = self.wTree.get_widget("ok8")
            self.ok9 = self.wTree.get_widget("ok9")

            self.ok1.hide()
            self.ok2.hide()
            self.ok3.hide()
            self.ok4.hide()
            self.ok5.hide()
            self.ok6.hide()
            self.ok7.hide()
            self.ok8.hide()
            self.ok9.hide()

            self.ok1.set_sensitive(False)
            self.ok2.set_sensitive(False)
            self.ok3.set_sensitive(False)
            self.ok4.set_sensitive(False)
            self.ok5.set_sensitive(False)
            self.ok6.set_sensitive(False)
            self.ok7.set_sensitive(False)
            self.ok8.set_sensitive(False)
            self.ok9.set_sensitive(False)
        except:
            print 'self.ok is makes exceptions'  
            
        self.labelStatus1.set_markup("")
        self.labelStatus2.set_markup("")
        self.labelStatus3.set_markup("")
        self.labelStatus4.set_markup("")
        self.labelStatus5.set_markup("")
        self.labelStatus6.set_markup("")
        self.labelStatus7.set_markup("")
        self.labelStatus8.set_markup("")
        self.labelStatus9.set_markup("")
        
        self.textb=gtk.TextBuffer()
        self.textview = self.wTree.get_widget("textview3").set_buffer(self.textb)
        self.textview = self.wTree.get_widget("textview3").set_justification(gtk.JUSTIFY_LEFT)
        last_iter = self.textb.get_end_iter()
        self.textb.insert(last_iter,"file: ")
        self.textb.insert(last_iter, filename)
        self.textb.insert(last_iter,"\n")
        last_iter = self.textb.get_end_iter()
        self.textb.insert(last_iter,"size ")
        self.textb.insert(last_iter,str(filesize))
        self.textb.insert(last_iter," [bytes]")  

        dic = {     "on_exit"            : self.exit,
                    "show_console"       : self.show_console,
                    "show_topology"      : self.show_topology,
                    "on_cancel"          : self.exit
              }
      
        self.wTree.signal_autoconnect(dic)


    #--------------------------------
    def update(self, state):
        if self.terminated is True:
            return

        gtk.gdk.threads_enter()
        span_start = "<span font_family=\"serif\" size=\"medium\">"
        span_end = "</span>"       
        if state == 1:
            self.labelStatus1.set_markup(span_start+"<b>Initializing the DDSS Backup synchronization utility</b>"+span_end)
            try: self.ok1.show()
            except: pass
            state+=1
        elif state == 2:
            self.labelStatus1.set_markup(span_start+"Initializing the DDSS Backup synchronization utility"+span_end)
            self.labelStatus2.set_markup(span_start+"<b>Connecting to the G2MPLS Control Plane</b>"+span_end)
            try:
                self.ok2.show()
                self.ok1.set_sensitive(True)
            except: pass
            state+=1  
        elif state == 3:
            self.labelStatus2.set_markup(span_start+"Connecting to the G2MPLS Control Plane"+span_end)
            self.labelStatus3.set_markup(span_start+"<b>Requesting for the storage capacity on remote servers</b>"+span_end)
            try:
                self.ok3.show()
                self.ok2.set_sensitive(True)
            except: pass
            state+=1
        elif state == 4:
            self.labelStatus3.set_markup(span_start+"Requesting for the storage capacity on remote servers"+span_end)
            self.labelStatus4.set_markup(span_start+"<b>Setting up the path to the chosen backup server</b>"+span_end)
            try:
                self.ok4.show()
                self.ok3.set_sensitive(True)
            except: pass
            state+=1
        elif state == 5:
            self.labelStatus4.set_markup(span_start+"Setting up the path to the chosen backup server"+span_end)
            self.labelStatus5.set_markup(span_start+"<b>Data plane connectivity check</b>"+span_end)
            try: 
                self.ok5.show()
                self.ok4.set_sensitive(True)
            except: pass
            #self.labelDDSS.set_markup("<span size=\"x-large\"><b>DDSS Backup (to server "+self.serv_addr+")</b></span>")
            self.labelDDSS.set_markup("<span size=\"x-large\"><b>DDSS Backup </b></span>")
            state+=1
        elif state == 6:
            self.labelStatus5.set_markup(span_start+"Data plane connectivity check"+span_end)
            self.labelStatus6.set_markup(span_start+"<b>Initializing the gridFTP utility</b>"+span_end)
            try:
                self.ok6.show()
                self.ok5.set_sensitive(True)
            except: pass
            state+=1
        elif state == 7:
            self.labelStatus6.set_markup(span_start+"Initializing the gridFTP utility"+span_end)
            self.labelStatus7.set_markup(span_start+"<b>Creating the backup on remote data server</b>"+span_end)
            try:
                self.ok7.show()
                self.ok6.set_sensitive(True)
            except: pass
            state+=1
        elif state == 8:
            self.labelStatus7.set_markup(span_start+"Creating the backup on remote data server"+span_end)
            self.labelStatus8.set_markup(span_start+"<b>Closing the connection</b>"+span_end)
            try:
                self.ok8.show()
                self.ok7.set_sensitive(True)
            except: pass
            state+=1
        elif state == 9:
            self.labelStatus8.set_markup(span_start+"Closing the connection"+span_end)
            self.labelStatus9.set_markup(span_start+"<b>Finalizing</b>"+span_end)
            try:
                self.ok9.show()
                self.ok8.set_sensitive(True)
            except: pass
        elif state == 10:
            self.labelStatus9.set_markup(span_start+"Finalizing"+span_end)
            try: self.ok9.set_sensitive(True)
            except: pass
            state+=1
        if state <= 9:
            self.step += 0.1
            self.progressbar.set_fraction(self.step)
            self.progressbar.set_text(str(self.step*100) + "%")
            #self.cin,self.cout = os.popen2("bash /home/artoor/Pulpit/run2.sh","w")
            #for line in self.cout:
            #    self.textb.insert_at_cursor(line)
            #    while gtk.events_pending():
            #        gtk.main_iteration(False)
        elif state == 10:
            self.progressbar.set_fraction(1.0)
            self.progressbar.set_text("100%")
        elif state == 11:
            self.progressbar.set_fraction(1.0)
            self.progressbar.set_text("Done")
            self.buttonCancel.set_label("Done")
            img = gtk.image_new_from_stock(gtk.STOCK_APPLY,  gtk.ICON_SIZE_BUTTON)
            self.buttonCancel.set_property("image", img)

        gtk.gdk.threads_leave()
    
    #--------------------------------
    def exit(self, widget):
        gtk.main_quit()
        self.terminated = True
        sys.exit()
        os.kill(os.getpid(), signal.SIGTERM)
        return False
    
    #--------------------------------
    def show_console(self, widget):
        global visible_console
        if visible_console == True:
            self.window.resize(390,364)
            self.fixed.move(self.buttonCancel,235,310)
            self.fixed.move(self.buttonShowTopology,35,310)
            self.fixed.move(self.statusbar,0,342)
            visible_console = False
        else:
            self.window.resize(390,490)
            self.fixed.move(self.buttonCancel,235,430)
            self.fixed.move(self.buttonShowTopology,35,430)
            self.fixed.move(self.statusbar,0,468)
            visible_console = True
        return False
    
    #------------------------------
    def show_topology(a,b):
        try:
            import gtkmozembed as moz
        except ImportError:
            print "[ERR] python-gtkmozembed module missing"
            dialog = gtk.Dialog('Warning',
                None,
                gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,                       
                (gtk.STOCK_OK, gtk.RESPONSE_CLOSE))
            dialog.vbox.pack_start(gtk.Label('Module \"python-gtkmozembed\" missing!\nCan\'t open a topology presentation.'))
            dialog.show_all()
            result = dialog.run()
            dialog.destroy()
            return

        def close_topology(widget, event):
            win.hide()
            return True

        moz.set_profile_path("/tmp/","phosp_monitor")
        gtkmoz = moz.MozEmbed()
        gtkmoz.load_url("http://150.254.171.133/testbed/phosphorus_testbed/fff/monitor.php")

        win = gtk.Window()
        win.connect('delete-event', close_topology)
        win.resize(1130,900)
        win.set_position(gtk.WIN_POS_CENTER)
        win.set_title('Phosphorus Monitor')

        win.add(gtkmoz)
        win.show_all()
        
    #--------------------------------  
    def Warn(self, text):
        dialog = gtk.Dialog('Warning',
                            None,
                            gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,                       
                            (gtk.STOCK_OK, gtk.RESPONSE_CLOSE))
        dialog.vbox.pack_start(gtk.Label(text))
        dialog.show_all()
        dialog.run()
    
    #--------------------------------    
    def WarnAndExit(self, text):
        dialog = gtk.Dialog('Warning',
                            None,
                            gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,                       
                            (gtk.STOCK_OK, gtk.RESPONSE_CLOSE))
        dialog.vbox.pack_start(gtk.Label(text))
        dialog.show_all()
        result = dialog.run()
        if result == gtk.RESPONSE_CLOSE:
            os.kill(os.getpid(), signal.SIGTERM)
        dialog.destroy()
        return

    #--------------------------------
    def main(self):
        gtk.main()
        
#=========================================================================

class MasterScript ( threading.Thread ):

    def __init__(self, window, testing):
       threading.Thread.__init__(self)
       self.window = window
       self.testing = testing

    #--------------------------------
    def run ( self ):
        DDSS_server_addr = '127.0.0.1'

        time.sleep(0.2)
        self.window.update(state=1)
        ### Initializing the DDSS Backup synchronization utility ###
        
        time.sleep(0.2)
        self.window.update(state=2)
        ### Connecting to the G2MPLS Control Plane ###


        time.sleep(0.2)
        self.window.update(state=3)
        ### Requesting for the storage capacity on remote servers ###


        time.sleep(0.2)
        self.window.update(state=4)
        ### Setting up the path to the chosen backup server ###
        try:
            fd = os.popen('du -ms %s' % self.window.filename)
            size = int(re.split('\t', fd.readlines()[0])[0])
        except:
            size = None
        try:
            fd.close()
        except:
            pass
        DDSS_server_addr = self.path_setup(size)
        self.window.serv_addr = DDSS_server_addr

        time.sleep(0.2)
        self.window.update(state=5)
        ### Data plane connectivity check ###
        if self.path_test(DDSS_server_addr): 
            time.sleep(0.2)
            self.window.update(state=6)
            ### Initializing the gridFTP utility ###
            self.gridftp_init()

            time.sleep(0.2)
            self.window.update(state=7)
            ### Creating the backup on remote data server ###
            self.send_file(filename=self.window.filename, destination=DDSS_server_addr)

        time.sleep(0.2)
        self.window.update(state=8)
        ### Closing the connection ###
        self.path_teardown()


        time.sleep(0.2)
        self.window.update(state=9)
        ### Finalizing ###


        time.sleep(0.2)
        self.window.update(state=10)
        ### The End ###
    
    #--------------------------------    
    def path_setup(self, size):
        if self.testing is True:
            return '127.0.0.1'
            
        try:
            res = setup_path(size)
        except Exception, ecc:
            print ecc
            self.window.WarnAndExit('Error during path setup')
            return
        
        guni_client_addr = res['DDSS_server_addr']
	DDSS_server_addr = SERVER.get(guni_client_addr)
        if DDSS_server_addr is None:
            self.window.WarnAndExit('g2dwrapper: The path cannot be established')
            return
            
        print "call %s is now UP; DDSS server is %s" % (res['callid'], DDSS_server_addr)
        return DDSS_server_addr
    
    #--------------------------------    
    def path_test(self, addr):
        if pingable(dest=addr, times=10) is True:
            print 'server %s is pingable' % addr
	    return True
        else:
            if self.testing is True:
                return True
                
            try:
                print 'Ping test unsuccessful, path teardown'                
                res = path_teardown()
            except Exception, ecc:
                print ecc
                self.window.WarnAndExit('Error during path teardown')
                return False
                
            if res['status'] == 'Failed':
                print "call %s is now DOWN" % res['callid']
                self.window.WarnAndExit('Connecting to DDSS backup failed...')
                return False
    
    #--------------------------------
    def gridftp_init(self):
        os.system('grid-proxy-init')
	
    #--------------------------------   
    def send_file(self, filename, destination):
        if self.testing is False:
            source = 'file://%s' % filename
            dest   = 'gsiftp://%s/home/ddss-storage/' % destination
            request = "globus-url-copy -p 48 -tcp-bs 256000 -bs 256000 %s %s" % (source, dest)
            try:
                print 'Grid-FTP request:', request
                import time
                start = time.time()
                os.system(request)
                print 'Grid-FTP transfer is finished in %s sec' % str(time.time()-start)
            except Exception, ecc:
                print ecc
                print "Grid-FTP req", request
                self.window.Warn('File %s send to %s unsuccessful' % (filename, destination))
		print 'Preparing for network path teardown'
		time.sleep(10.0)
    
    #--------------------------------
    def path_teardown(self):
        if self.testing is True:
            return
            
        try:                
            res = path_teardown()
	    time.sleep(3)
        except Exception, ecc:
            print ecc
            self.window.WarnAndExit('Error during path teardown')
            return
            
        if res['status'] == 'Failed':
            self.window.WarnAndExit('Path teardown failed')
            return
        print "call is now DOWN"

    #--------------------------------

#=========================================================================  

def setup_path(size):
    if size is not None:
#        cmd = "/usr/local/bin/g2dwrapper.sh -q -p ~/call_params_storage.py -s %d -c setup|grep RESULT" % size
        cmd = "ssh root@192.168.150.115 '/usr/local/bin/g2dwrapper.sh -q -p ~/call_params_storage.py -s %d -c setup|grep RESULT'" % size
    else:
#        cmd = "/usr/local/bin/g2dwrapper.sh -q -p ~/call_params_storage.py -c setup|grep RESULT"
        cmd = "ssh root@192.168.150.115 '/usr/local/bin/g2dwrapper.sh -q -p ~/call_params_storage.py -c setup|grep RESULT'"
    print "running: ", cmd
    f = os.popen(cmd)
    result = f.readlines()[0][:-1]
    f.close()
    print "result = '%s'" % result
    flds = re.split(' ', result)
    if flds[1] == 'up':
        return dict(callid           = flds[2],
                    DDSS_server_addr = flds[3])
    elif flds[1] == 'down':
        return dict(callid           = flds[2],
                    DDSS_server_addr = None)
    else:
        return dict(callid           = flds[2],
                    DDSS_server_addr = None,
                    result           = result)
      
 
#-------------------------------------------------------------------------
def path_teardown():
#    f = os.popen("/usr/local/bin/g2dwrapper.sh -q -p ~/call_params_storage.py -c teardown|grep RESULT")
    f = os.popen("ssh root@192.168.150.115 '/usr/local/bin/g2dwrapper.sh -q -p ~/call_params_storage.py -c teardown|grep RESULT'")
    result = f.readlines()[0][:-1]
    f.close()
    print "result = '%s'" % result
    flds = re.split(' ', result)
    if flds[1] == 'down':
        return dict(callid = flds[2],
                    status = 'Success')
    else: # failed
        return dict(callid = flds[2],
                    status = 'Failed',
                    result = result)
                    
#-------------------------------------------------------------------------

def pingable(dest, times=10):
    print 'Pinging %s test started' % dest
    ping_stats_patt = re.compile('^rtt min/avg/max/mdev = (?P<min>[^/]*)/(?P<avg>[^/]*)/(?P<max>[^/]*)/(?P<mdev>[^ ]*) ms')
    for i in range(times):
        stdout, stdin, strerr = popen3("ping %s -c 1" % dest)
        ping_resp = stdout.readlines()
        last_line = ping_resp[-1]
        print last_line
        match = ping_stats_patt.search(last_line)
        if match:
            return True
    return False

#=========================================================================

if __name__ == "__main__":
    
    gtk.gdk.threads_init()
    
    try:
        # run from filebrowser
        filename = sys.argv[2]
        testing = False
    except Exception, e:
        # standalone test run
        print e
        filename = "%s/%s" % (os.getcwd(), __file__)
        testing = True
    
    try:    
        size = os.path.getsize(filename)
    except Exception, e:
        print e
        size = 0
            
    window = DDSS_backup(filename, size)

    ms = MasterScript(window, testing)
    ms.start()

    window.main()







    

