[+ Autogen5 template
h=%s_gen.h
cpp=%s_gen.cpp
+][+
   (define found_root_ev #f)
+]
[+ CASE (suffix) +]
[+ == h +]
#ifndef FSMGEN_H
#define FSMGEN_H
//
// This file has been generated automatically, DO NOT CHANGE !
//

#ifndef FSMGEN_UTILITY
#define FSMGEN_UTILITY

#include <iostream>
#include <stdio.h>
#include <string>
#include <map>
#include <list>
#include <stdlib.h>

/*****************************************************************************/
/*                          Utility - Matrix class                           */
/*****************************************************************************/

template <class ROW, class COLUMN, class DATA>
class Matrix {
public:
	Matrix() { }
	~Matrix() { }

	//friend class Fsm;

	// Copy operator
	Matrix(const Matrix<ROW, COLUMN, DATA>& m) { matrix_ = m.matrix_; }

	//
	// Type definitions
	//
	typedef ROW *          rowIter;
	typedef const ROW *    const_rowIter;
	typedef COLUMN *       colIter;
	typedef const COLUMN * const_colIter;
	typedef DATA *         dataIter;
	typedef const DATA *   const_dataIter;

	//
	// Iterator support
	//
	rowIter begin(void);
	const_rowIter begin(void) const;
	rowIter end(void);
	const_rowIter end(void) const;
	rowIter next(rowIter rowIt);
	const_rowIter next(const_rowIter rowIt) const;
	colIter begin(rowIter rowIt);
	const_colIter begin(const_rowIter rowIt) const;
	colIter end(rowIter rowIt);
	const_colIter end(const_rowIter rowIt) const;
	colIter next(rowIter rowIt, colIter colIt);
	const_colIter next(const_rowIter rowIt, const_colIter colIt) const;


	// Return the number of deleted cells within the row
	size_t removeRow(const ROW& row);

	// Return the number of deleted cells within the column
	size_t removeCol(const COLUMN& column);

	// Return the number (1 or 0) of deleted data for this pair row/column
	size_t remove(const ROW& row, const COLUMN& column);

	// Return the number of deleted data
	size_t remove(const DATA& data);

	bool remove(dataIter dIt);

	void insert(const ROW& row, const COLUMN& column, const DATA& data);

	dataIter find(const ROW& row, const COLUMN& column);

	// Return the number of data
	size_t size(void) const;

	bool empty(void) const;

	// Assignment operator
	Matrix<ROW, COLUMN, DATA>& operator=(const Matrix<ROW,COLUMN,DATA>& o);

	std::map<COLUMN, DATA>& operator[](const ROW s);

	friend std::ostream& operator<<(std::ostream& s, const Matrix& m) {
		typename std::map<ROW,
			std::map<COLUMN, DATA> >::const_iterator rIt;
		for (rIt = m.matrix_.begin(); rIt != m.matrix_.end(); rIt++) {
			s << "[" << (*rIt).first << "] ";

			typename std::map<COLUMN, DATA>::const_iterator cIt;
			for (cIt = (*rIt).second.begin();
			     cIt != (*rIt).second.end();
			     cIt++) {
				if (cIt != (*rIt).second.begin()) {
					s << " - ";
				}
				s << (*cIt).first << "/" << (*cIt).second;
			}

			s << std::endl;
		}
		return s;
	}

private:
	std::map< ROW, std::map<COLUMN, DATA> > matrix_;
};


template <class ROW, class COLUMN, class DATA>
size_t
Matrix<ROW, COLUMN, DATA>::removeRow(const ROW& row)
{
	size_t count;
	count = 0;
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;

	rIt = matrix_.find(row);
	if (rIt != matrix_.end()) {
		//std::cout << "Removed row: " << (*rIt).first
		//	  << std::endl;
		count += (*rIt).second.size();
		matrix_.erase(rIt);
	}

	return count;
}

template <class ROW, class COLUMN, class DATA>
size_t
Matrix<ROW, COLUMN, DATA>::removeCol(const COLUMN& column)
{
	size_t count;
	count = 0;
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;

	for (rIt = matrix_.begin(); rIt != matrix_.end(); rIt++) {
		typename std::map<COLUMN, DATA>::iterator cIt;

		cIt = (*rIt).second.find(column);
		if (cIt != (*rIt).second.end()) {
			//std::cout << "Removed col: " << (*cIt).first
			//	  << std::endl;
			(*rIt).second.erase(cIt);
			count++;
		}
	}

	return count;
}

template <class ROW, class COLUMN, class DATA>
size_t
Matrix<ROW, COLUMN, DATA>::remove(const ROW& row, const COLUMN& column)
{
	size_t count;
	count = 0;
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;

	rIt = matrix_.find(row);
	if (rIt != matrix_.end()) {
		//std::cout << "Row: " << (*rIt).first << std::endl;
		typename std::map<COLUMN, DATA>::iterator cIt;

		cIt = (*rIt).second.find(column);
		if (cIt != (*rIt).second.end()) {
			//std::cout << "  Col: " << (*cIt).first
			//	  << std::endl
			//	  << "    Removed data: "
			//	  << (*cIt).second << std::endl;
			(*rIt).second.erase(cIt);
			count++;
		}
	}

	return count;
}

template <class ROW, class COLUMN, class DATA>
size_t
Matrix<ROW, COLUMN, DATA>::remove(const DATA& data)
{
	size_t count;
	count = 0;
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;

	for (rIt = matrix_.begin(); rIt != matrix_.end(); rIt++) {
		typename std::map<COLUMN, DATA>::iterator cIt;
		cIt = (*rIt).second.begin();
		while (cIt != (*rIt).second.end()) {
			if ((*cIt).second == data) {
				(*rIt).second.erase(cIt++);
				count++;
				continue;
			}
			cIt++;
		}
	}

	return count;
}

template <class ROW, class COLUMN, class DATA>
bool
Matrix<ROW, COLUMN, DATA>::remove(dataIter dIt)
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;

	for (rIt = matrix_.begin(); rIt != matrix_.end(); rIt++) {
		typename std::map<COLUMN, DATA>::iterator cIt;
		for (cIt = (*rIt).second.begin();
		     cIt != (*rIt).second.end();
		     cIt++) {
			if (dIt == &(*cIt).second) {
				(*rIt).second.erase(cIt);
				return true;
			}
		}
	}

	return false;
}

template <class ROW, class COLUMN, class DATA>
void
Matrix<ROW, COLUMN, DATA>::insert(const ROW& row,
				  const COLUMN& column,
				  const DATA& data)
{
	matrix_[row][column] = data;
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::dataIter
Matrix<ROW, COLUMN, DATA>::find(const ROW& row, const COLUMN& column)
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;

	rIt = matrix_.find(row);
	if (rIt != matrix_.end()) {
		//std::cout << "Row: " << (*rIt).first << std::endl;
		typename std::map<COLUMN, DATA>::iterator cIt;

		cIt = (*rIt).second.find(column);
		if (cIt != (*rIt).second.end()) {
			//std::cout << "  Col: " << (*cIt).first
			//	  << std::endl
			//	  << "    Removed data: "
			//	  << (*cIt).second << std::endl;
			return (dataIter)&((*cIt).second);
		}
	}

	return (dataIter)0;
}

template <class ROW, class COLUMN, class DATA>
size_t
Matrix<ROW, COLUMN, DATA>::size(void) const
{
	size_t count;
	count = 0;
	typename std::map< ROW, std::map<COLUMN, DATA> >::const_iterator rIt;

	for (rIt = matrix_.begin(); rIt != matrix_.end(); rIt++) {
		count += (*rIt).second.size();
	}

	return count;
}

template <class ROW, class COLUMN, class DATA>
bool
Matrix<ROW, COLUMN, DATA>::empty(void) const
{
	return size() ? false : true;
}

template <class ROW, class COLUMN, class DATA>
Matrix<ROW, COLUMN, DATA>&
Matrix<ROW, COLUMN, DATA>::operator=(const Matrix<ROW, COLUMN, DATA>& orig)
{
	if(this != &orig) {
		typename std::map< ROW, std::map<COLUMN,DATA> >::iterator rIt;
		for (rIt=matrix_.begin(); rIt!=matrix_.end(); rIt++) {
			(*rIt).second.clear();
		}
		matrix_.clear();

		matrix_ = orig.matrix_;
	}
	return *this;
}

template <class ROW, class COLUMN, class DATA>
std::map<COLUMN, DATA>&
Matrix<ROW, COLUMN, DATA>::operator[](const ROW s)
{
	return matrix_[s];
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::rowIter
Matrix<ROW, COLUMN, DATA>::begin(void)
{
	return (rowIter)&((*(matrix_.begin())).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::const_rowIter
Matrix<ROW, COLUMN, DATA>::begin(void) const
{
	return (const_rowIter)&((*(matrix_.begin())).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::rowIter
Matrix<ROW, COLUMN, DATA>::end(void)
{
	return (rowIter)&((*(matrix_.end())).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::const_rowIter
Matrix<ROW, COLUMN, DATA>::end(void) const
{
	return (const_rowIter)&((*(matrix_.end())).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::rowIter
Matrix<ROW, COLUMN, DATA>::next(rowIter rowIt)
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;
	rIt = matrix_.find(*rowIt);
	rIt++;
	return (rowIter)&((*rIt).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::const_rowIter
Matrix<ROW, COLUMN, DATA>::next(const_rowIter rowIt) const
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::const_iterator rIt;
	rIt = matrix_.find(*rowIt);
	rIt++;
	return (const_rowIter)&((*rIt).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::colIter
Matrix<ROW, COLUMN, DATA>::begin(rowIter rowIt)
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;
	typename std::map<COLUMN, DATA>::iterator cIt;
	rIt = matrix_.find(*rowIt);
	cIt = (*rIt).second.begin();
	return (colIter)&((*cIt).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::const_colIter
Matrix<ROW, COLUMN, DATA>::begin(const_rowIter rowIt) const
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::const_iterator rIt;
	typename std::map<COLUMN, DATA>::const_iterator  cIt;
	rIt = matrix_.find(*rowIt);
	cIt = (*rIt).second.begin();
	return (const_colIter)&((*cIt).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::colIter
Matrix<ROW, COLUMN, DATA>::end(rowIter rowIt)
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;
	typename std::map<COLUMN, DATA>::iterator cIt;
	rIt = matrix_.find(*rowIt);
	cIt = (*rIt).second.end();
	return (colIter)&((*cIt).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::const_colIter
Matrix<ROW, COLUMN, DATA>::end(const_rowIter rowIt) const
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::const_iterator rIt;
	typename std::map<COLUMN, DATA>::const_iterator  cIt;
	rIt = matrix_.find(*rowIt);
	cIt = (*rIt).second.end();
	return (const_colIter)&((*cIt).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::colIter
Matrix<ROW, COLUMN, DATA>::next(rowIter rowIt, colIter colIt)
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::iterator rIt;
	typename std::map<COLUMN, DATA>::iterator cIt;
	rIt = matrix_.find(*rowIt);
	cIt = (*rIt).second.find(*colIt);
	cIt++;
	return (colIter)&((*cIt).first);
}

template <class ROW, class COLUMN, class DATA>
typename Matrix<ROW, COLUMN, DATA>::const_colIter
Matrix<ROW, COLUMN, DATA>::next(const_rowIter rowIt,
				const_colIter colIt) const
{
	typename std::map< ROW, std::map<COLUMN, DATA> >::const_iterator rIt;
	typename std::map<COLUMN, DATA>::const_iterator  cIt;
	rIt = matrix_.find(*rowIt);
	cIt = (*rIt).second.find(*colIt);
	cIt++;
	return (const_colIter)&((*cIt).first);
}
#endif // FSMGEN_UTILITY

namespace fsm {
	[+ FOR fsm +]
	[+ DEFINE fsm-name +][+ (get "name") +][+ ENDDEF +]
#ifndef NAMESPACE_BASE_[+ fsm-name +]
#define NAMESPACE_BASE_[+ fsm-name +]

#include <iostream>
#include <stdio.h>
#include <string>
#include <map>
#include <list>
#include <stdlib.h>

/*****************************************************************************/
/*                             Finite State Machine                          */
/*****************************************************************************/
	/*************************************/
	/*    Finite State Machine - Core    */
	/*************************************/
	namespace base_[+ fsm-name +] {

#define STATE_NAME(x) [+ FOR states +][+ FOR state +]             \
  ((x == fsm::base_[+ fsm-name +]::Fsm::[+ fsm-name +]_[+(get "state")+] ? "[+
  (get "state") +]" : [+ ENDFOR state +][+ ENDFOR states +][+
  FOR virtual-states +][+ FOR state +]\
  ((x == fsm::base_[+ fsm-name +]::Fsm::[+ fsm-name +]_[+(get "state")+] ? "[+
  (get "state") +]" : [+ ENDFOR state +][+ ENDFOR virtual-states +]    \
		       "Unknown"[+ FOR states +][+ FOR state +]))[+
				 ENDFOR state +][+ ENDFOR states +][+
				 FOR virtual-states +][+ FOR state +]))[+
				 ENDFOR state +][+ ENDFOR virtual-states +]

#define EVENT_NAME(x) [+ FOR events +][+ FOR event +]             \
  ((x == fsm::base_[+ fsm-name +]::Fsm::[+ fsm-name +]_[+(get "event")+] ? "[+
  (get "event") +]" : [+ ENDFOR event +][+ ENDFOR events +][+
  FOR root-events +][+ FOR event +]\
  ((x == fsm::base_[+ fsm-name +]::Fsm::[+ fsm-name +]_[+(get "event")+] ? "[+
 (get "event") +]" : [+ ENDFOR event +][+ ENDFOR root-events +]     \
		       "Unknown"[+ FOR events +][+ FOR event +]))[+
				 ENDFOR event +][+ ENDFOR events +][+
				 FOR root-events +][+ FOR event +]))[+
				 ENDFOR event +][+ ENDFOR root-events +]

#define DUMP(level, threshold, tag, str)				\
		if ((level) <= threshold) {				\
			std::cout << "[" << getpid() << "]"		\
				  << "[" << __FUNCTION__ << "]: "	\
				  << "[" << tag << "] "			\
				  << str				\
				  << std::endl;				\
		}

		[+ FOR event-hierarchy +][+ FOR relationship +]
		enum nextEvFor_[+ (get "root-event") +]_t {
			[+ fsm-name +]_from_[+ (get "root-event")
					     +]_to_InvalidEvent = 0,
			[+ FOR event +][+ fsm-name +]_from_[+ (get "root-event") +]_to_[+ (get "event") +],
			[+ ENDFOR event +]
		};
		[+ ENDFOR event-hierarchy +][+ ENDFOR relationship +]

		class State {
		public:
			State(std::string name = "Base state") :
				name_(name) { }
			virtual ~State(void) { }

			std::string name(void) { return name_; }

			// On event
			[+ FOR events +][+ FOR event +]
			virtual bool [+ (get "event") +](void * context) {
				throw(std::string("Undefined transition on event "
				      "'[+ (get "event") +]'"));
			}
			[+ ENDFOR event +][+ ENDFOR events +][+
			   FOR root-events +][+ FOR event +]
			virtual nextEvFor_[+ (get "event") +]_t [+
					     (get "event") +](void * context) {
				throw(std::string("Undefined transition on event "
				      "'[+ (get "event") +]'"));
			}
			[+ ENDFOR event +][+ ENDFOR root-events +]

			// After event from state
			[+ FOR transitions +] [+ FOR transition +]
			virtual void after_[+ (get "on-event") +]_from_[+ (get "from-state") +](void * context) {
				throw(std::string("Undefined transition after event "
				      "'[+ (get "on-event") +]' from state "
				      "'[+ (get "from-state") +]'"));
			}
			[+ ENDFOR transition +][+ ENDFOR transitions +]

		private:
			std::string name_;
		};

		/*
		 *  Classes that MUST be derived!!! - START
		 */
		[+ FOR states +][+ FOR state
		 +]class [+ (get "state") +]_i;
		[+ ENDFOR state +][+ ENDFOR states +]
		[+ FOR virtual-states +][+ FOR state
		 +]class [+ (get "state") +]_i;
		[+ ENDFOR state +][+ ENDFOR virtual-states +]

		[+ FOR states +][+ FOR state +]
		class [+ (get "state") +] : public State {
		public:
			[+ (get "state") +]() :
				State(std::string("[+ (get "state") +]")) { }
			virtual ~[+ (get "state") +]() { }
			[+ FOR transitions +] [+ FOR transition +] [+
			   IF (== (get "from-state") (get "state")) +][+
(set! found_root_ev #f) +][+
 FOR root-events +][+ FOR event +][+
  IF (== (get "on-event") (get "event")) +][+ (set! found_root_ev #t) +][+ ENDIF +][+
 ENDFOR event +][+ ENDFOR root-events +][+
			IF (. found_root_ev) +]
			virtual fsm::base_[+ fsm-name +]::nextEvFor_[+
				(get "on-event") +]_t [+ (get "on-event")
						       +](void* context) = 0;
			[+ ELSE +]
			virtual bool [+ (get "on-event") +](void* context) = 0;
			[+ ENDIF +][+
			   ENDIF +][+
			   IF (== (get "to-state") (get "state")) +]
			virtual void after_[+ (get "on-event") +]_from_[+ (get "from-state") +](void * context) = 0;
			[+ ENDIF +] [+
			ENDFOR +][+ ENDFOR +]
		};
		[+ ENDFOR +][+ ENDFOR +][+
		   FOR virtual-states +][+ FOR state +]
		class [+ (get "state") +] : public State {
		public:
			[+ (get "state") +]() :
				State(std::string("[+ (get "state") +]")) { }
			virtual ~[+ (get "state") +]() { }
			[+ FOR transitions +] [+ FOR transition +] [+
			   IF (== (get "from-state") (get "state")) +][+
(set! found_root_ev #f) +][+
 FOR root-events +][+ FOR event +][+
  IF (== (get "on-event") (get "event")) +][+ (set! found_root_ev #t) +][+ ENDIF +][+
 ENDFOR event +][+ ENDFOR root-events +][+
			IF (. found_root_ev) +]
			virtual fsm::base_[+ fsm-name +]::nextEvFor_[+
				(get "on-event") +]_t [+ (get "on-event")
						       +](void* context) = 0;
			[+ ELSE +]
			virtual bool [+ (get "on-event") +](void* context) = 0;
			[+ ENDIF +][+
			   ENDIF +][+
			   IF (== (get "to-state") (get "state")) +]
			virtual void after_[+ (get "on-event") +]_from_[+ (get "from-state") +](void * context) = 0;
			[+ ENDIF +] [+
			ENDFOR +][+ ENDFOR +]
		};
		[+ ENDFOR state +][+ ENDFOR virtual-states +]
		/*
		 *  Classes that MUST be derived!!! - END
		 */

		class BaseFSM {
		public:
			enum traceLevel_t {
				TRACE_DBG = 0,
				TRACE_LOG,
				TRACE_INF,
				TRACE_WRN,
				TRACE_ERR
			};

			BaseFSM(traceLevel_t level = TRACE_DBG) :
				level_(level),
				name_(std::string("[+ fsm-name +]")) { }
			virtual ~BaseFSM(void) { }

			std::string name(void) { return name_; }

			traceLevel_t traceLevel(void) {	return level_; }

			void traceLevel(traceLevel_t level) { level_ = level; }

			void dbg(std::string text) {
				DUMP(level_, TRACE_DBG, name_, text);
			}

			void log(std::string text) {
				DUMP(level_, TRACE_LOG, name_, text);
			}

			void inf(std::string text) {
				DUMP(level_, TRACE_INF, name_, text);
			}

			void wrn(std::string text) {
				DUMP(level_, TRACE_WRN, name_, text);
			}

			void err(std::string text) {
				DUMP(level_, TRACE_ERR, name_, text);
			}

		private:
			traceLevel_t level_;
		protected:
			std::string  name_;
		};

		/*
		 *  Class for checking FSM integrity ... not FULL IMPLEMENTED
		 */
		class GenericFSM : public BaseFSM {
		public:
			GenericFSM(traceLevel_t level = TRACE_DBG) :
				BaseFSM(level),
				changeInProgress_(false) { }
			virtual ~GenericFSM(void) { }

			bool startModify(void);
			bool endModify(void);

			//TODO: callback????
			typedef void (* callback_t) (std::string from_state,
						     std::string to_state,
						     std::string on_event,
						     void *      context);

			//// CallBack
			//bool addPreCallBack(callback_t cb,
			//		   void *     context);
			//bool addPostCallback(callback_t cb,
			//		    void *     context);
			//bool addInCallback(callback_t cb,
			//		  void * context);
			//
			//bool remPreCallBack(callback_t cb);
			//bool remPostCallback(callback_t cb);
			//bool remInCallback(callback_t cb);


			// States
			bool addState(std::string state);
			bool remState(std::string state);

			// Events
			bool addEvent(std::string event);
			bool remEvent(std::string event);

			// Transitions
			bool addTransition(std::string from,
					   std::string to,
					   std::string event);
			bool remTransition(std::string from,
					   std::string to,
					   std::string event);

			// General
			bool setStartState(std::string state);

			//bool run(std::string event);
			//std::string getState(void);

			//operator<<
			//operator>>

		private:
			bool check(void);

			struct state_data_t {
				callback_t  pre;
				callback_t  post;
				callback_t  in;
			};

			Matrix<std::string,
			       std::string,
			       std::string>                 transitions_;
			std::map<callback_t, void *>        contexts_;
			std::map<std::string, state_data_t> states_;
			std::list<std::string>              events_;
			bool                                changeInProgress_;
			std::string                         startState_;
		};

		class Fsm : public GenericFSM {
		public:
			/*  add/rem of states/events/callback for
			 *  checking FSM consistency
			 */
			Fsm(traceLevel_t level = TRACE_DBG)
				throw(std::string);

			virtual ~Fsm(void);

			friend std::ostream& operator<<(std::ostream&  s,
							const Fsm& f);

			[+ FOR events +][+ FOR event +]
			bool [+ (get "event") +](void * context);
			[+ ENDFOR event +][+ ENDFOR events +][+
			   FOR root-events +][+ FOR event +]
			nextEvFor_[+ (get "event") +]_t [+ (get "event") +](void * context);
			[+ ENDFOR event +][+ ENDFOR root-events +]

			//operator<<
			//operator>>

			State * currentState(void);
			bool    go2prevState(void);

		private:
			enum states_t {
				[+ FOR states +][+ FOR state +][+
				fsm-name +]_[+ (get "state") +],
				[+ ENDFOR state +][+ ENDFOR states +][+
				   FOR virtual-states +][+ FOR state +][+
				fsm-name +]_[+ (get "state") +],
				[+ ENDFOR state +][+ ENDFOR virtual-states +]
			};

			enum events_t {
				[+ FOR events +][+ FOR event +][+
				fsm-name +]_[+ (get "event") +],
				[+ ENDFOR event +][+ ENDFOR events +][+
				   FOR root-events +][+ FOR event +][+
				fsm-name +]_[+ (get "event") +],
				[+ ENDFOR event +][+ ENDFOR root-events +]
			};

			friend std::ostream& operator<<(std::ostream&   s,
							const states_t& st);

			friend std::ostream& operator<<(std::ostream&   s,
							const events_t& ev);

			states_t                             currentState_;
			states_t                             prevState_;
			std::map<states_t, State *>          states_;
			Matrix<states_t, events_t, states_t> nextState_;
		};
	}
#endif // NAMESPACE_[+ fsm-name +]
	[+ ENDFOR fsm +]



	/*************************************/
	/*   Finite State Machine - Wrapper  */
	/*************************************/
	[+ FOR fsm +]
	[+ DEFINE fsm-name +][+ (get "name") +][+ ENDDEF +]

#ifndef NAMESPACE_[+ fsm-name +]
#define NAMESPACE_[+ fsm-name +]

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string>
#include <map>
#include <list>
#include <iostream>

	namespace [+ fsm-name +] {

		class virtFsm {
		public:
			virtFsm(base_[+ fsm-name +]::BaseFSM::traceLevel_t
				level =	base_[+ fsm-name +]::BaseFSM::TRACE_DBG)
				throw(std::string);

			virtual ~virtFsm(void);

			friend std::ostream& operator<<(std::ostream&  s,
							const virtFsm& f);

			enum root_events_t {
				//[+ fsm-name +]_invalid_event,
				[+ FOR root-events +][+ FOR event +][+
				fsm-name +]_[+ (get "event") +],
				[+ ENDFOR event +][+ ENDFOR root-events +]
			};

			void post(root_events_t ev, void * context, bool enqueue = false);

			std::string currentState(void);

		private:
			void runPendingWork(void);

			[+ FOR root-events +][+ FOR event +]
			void [+ (get "event") +](void * context);
			[+ ENDFOR event +][+ ENDFOR root-events +]

			typedef struct {
				root_events_t ev;
				void *        context;
			} data_event_t;

			base_[+ fsm-name +]::Fsm * fsm_;
			std::list<data_event_t *>  events_;
		};

	}
#endif // NAMESPACE_[+ fsm-name +]
	[+ ENDFOR fsm +]
}

#endif // FSMGEN_H
[+ == cpp +]
//
// This file has been generated automatically, DO NOT CHANGE !
//

#include <iostream>
#include <stdio.h>
#include <string>
#include <map>
#include <list>
#include <stdlib.h>
#include "[+ (base-name) +]_gen.h"

[+ FOR fsm +]
[+ IF (match-value? *= "include-name" ".h") +]
#include "[+ (get "include-name") +]"
[+ ENDIF +]
[+ ENDFOR fsm +]

/*****************************************************************************/
/*                             Finite State Machine                          */
/*****************************************************************************/
namespace fsm {
	[+ FOR fsm +]
	[+ DEFINE fsm-name +][+ (get "name") +][+ ENDDEF +]
	/*************************************/
	/*    Finite State Machine - Core    */
	/*************************************/
	namespace base_[+ fsm-name +] {

		//
		// State/s
		//

		//
		// BaseFSM
		//

		//
		// GenericFSM
		//
		bool GenericFSM::startModify(void)
		{
			if (changeInProgress_) {
				err("Changes already in progress ... call "
				    "endModify before!!!");
				return false;
			}
			dbg("### Start FSM changes");
			changeInProgress_ = true;
			return true;
		}

		bool GenericFSM::endModify(void)
		{
			if (!check()) {
				err("End FSM changes ... FAILED ###");
				return false;
			}
			dbg("End FSM changes ###");
			changeInProgress_ = false;
			return true;
		}

		bool GenericFSM::addState(std::string state)
		{
			if (!changeInProgress_) {
				err("Call startModify before any changes!!!");
				return false;
			}

			if (state.empty()) {
				err("Invalid state: string is empty");
				return false;
			}

			std::map<std::string, state_data_t>::iterator it;
			it = states_.find(state);
			if (it != states_.end()) {
				err("State " + state + " already added");
				return false;
			}

			state_data_t data;
			data.pre       = 0;
			data.post      = 0;
			data.in        = 0;
			states_[state] = data;

			dbg("Added state: " + state);
			return true;
		}

		bool GenericFSM::remState(std::string state)
		{
			if (!changeInProgress_) {
				err("Call startModify before any changes!!!");
				return false;
			}

			if (state.empty()) {
				err("Invalid state: string is empty");
				return false;
			}

			if (!states_.erase(state)) {
				err("State " + state + " not present");
				return false;
			}

			// Remove all the rows == state
			transitions_.removeRow(state);

			// Remove all the data (to-state) == state
			transitions_.remove(state);

			dbg("Removed state: " + state);

			if (startState_ == state) {
				wrn("State '" + state + "' was the start state"
				    " ... change it!!!");
				startState_ = std::string();
			}

			return true;
		}

		bool GenericFSM::addEvent(std::string event)
		{
			if (!changeInProgress_) {
				err("Call startModify before any changes!!!");
				return false;
			}

			if (event.empty()) {
				err("Invalid event: string is empty");
				return false;
			}

			std::list<std::string>::iterator it;
			it = find(events_.begin(),events_.end(),event);
			if (it != events_.end()) {
				err("Event " + event + " already added");
				return false;
			}
			events_.push_back(event);
			dbg("Added event: " + event);
			return true;
		}

		bool GenericFSM::remEvent(std::string event)
		{
			if (!changeInProgress_) {
				err("Call startModify before any changes!!!");
				return false;
			}

			if (event.empty()) {
				err("Invalid event: string is empty");
				return false;
			}

			events_.remove(event);

			// Remove all the columns == event
			transitions_.removeCol(event);

			dbg("Removed event: " + event);
			return true;
		}

		bool GenericFSM::addTransition(std::string from,
					       std::string to,
					       std::string event)
		{
			if (!changeInProgress_) {
				err("Call startModify before any changes!!!");
				return false;
			}

			if (from.empty() || to.empty() ||
			    event.empty()) {
				err("Invalid transition: some data are empty");
				return false;
			}

			Matrix<std::string,
				std::string,
				std::string>::dataIter it;
			it = transitions_.find(from, event);
			if (it != 0) {
				err("Transition from state '" + from + "' with"
				    " event '" + event + "' already added");
				return false;
			}

			transitions_[from][event] = to;
			dbg("Added transition: from state '" + from +
			    "' to state '" + to + "' with event '" +
			     event + "'");
			return true;
		}

		bool GenericFSM::remTransition(std::string from,
					       std::string to,
					       std::string event)
		{
			if (!changeInProgress_) {
				err("Call startModify before any changes!!!");
				return false;
			}

			if (from.empty() || to.empty() || event.empty()) {
				err("Invalid transition: some data are empty");
				return false;
			}

			Matrix<std::string,
				std::string,
				std::string>::dataIter it;
			it = transitions_.find(from, event);
			if (it != 0 && *it != to) {
				err("To-state for the transition from state '"
				    + from + "' event '" + event + "' is not '"
				    + to + "' but '" + *it + "'");
				return false;
			}

			if (!transitions_.remove(it)) {
				err("Transition from state '" + from +
				    "' to state '"+ to + "' with event '" +
				    event + "' is not present");
				return false;
			}

			dbg("Removed transition: from state '" + from +
			    "' to state '"+ to + "' with event '" + event +
			    "'");
			return true;
		}

		bool GenericFSM::setStartState(std::string state)
		{
			if (state.empty()) {
				err("Impossible to set start state to "
				    + state);
				return false;
			}

			dbg(std::string("Setting start state to ") + state);
			startState_ = state;
			return true;
		}

		bool GenericFSM::check(void)
		{
			dbg("Checking FSM integrity ...");

			if (transitions_.empty() && states_.empty()) {
				dbg("The FSM is completely empty!!!");
				return true;
			}

			if (states_.find(startState_) ==
			    states_.end()) {
				err("The start state is not a valid state");
				return false;
			}

			/*
			 *  Check if any transition state/event belong
			 *  to FSM states and events
			 */
			Matrix<std::string,
				std::string,
				std::string>::rowIter rowIt;
			for (rowIt = transitions_.begin();
			     rowIt != transitions_.end();
			     rowIt = transitions_.next(rowIt)) {

				// Check from-state
				if (states_.find(*rowIt) == states_.end()) {
					err("From-state " + *rowIt +
					    " is not a valid state");
					return false;
				}
				dbg("From-state '" + *rowIt +
				    "' is a valid state");

				Matrix<std::string,
					std::string,
					std::string>::colIter colIt;
				for (colIt = transitions_.begin(rowIt);
				     colIt != transitions_.end(rowIt);
				     colIt = transitions_.next(rowIt, colIt)){

					// Check event
					if (find(events_.begin(),
						 events_.end(),
						 *colIt) == events_.end()) {
						err("Event " + *colIt +
						    " is not a valid event");
						return false;
					}
					dbg("Event '" + *colIt +
					    "' is a valid event");

					// Check to-state
					std::string tmp;
					tmp = transitions_[*rowIt][*colIt];
					if (states_.find(tmp) ==
					    states_.end()) {
						err("To-state " + tmp +
						    " is not a valid state");
						return false;
					}
					dbg("To-state '" + tmp +
					    "' is a valid state");
				}
			}

			//TODO Graph check (partitioned/discontinued..)

			return true;
		}


		//
		// Fsm
		//
		Fsm::Fsm(traceLevel_t level)
			throw(std::string) :
			GenericFSM(level)
		{
			if (!startModify()) {
				throw(std::string("Impossible to init FSM"));
			}

			if (!setStartState("[+(get "start-state")+]")) {
				throw(std::string("Impossible to set start "
						  "state for th FSM"));
			}
			currentState_ = [+ fsm-name +]_[+(get "start-state")+];
			prevState_    = currentState_;

			[+ FOR transitions +][+ FOR transition +]
			if (!addTransition("[+ (get "from-state") +]",
					   "[+ (get "to-state") +]",
					   "[+ (get "on-event") +]")) {
				throw(std::string("Impossible to add "
						  "transition .... "));
			}

			nextState_[[+ fsm-name +]_[+ (get "from-state") +]][[+
				 fsm-name +]_[+ (get "on-event") +]] = [+
				 fsm-name +]_[+ (get "to-state") +]; [+
			ENDFOR +][+ ENDFOR +]

			[+ FOR states +][+ FOR state +]
			if (!addState("[+ (get "state") +]")) {
				throw(std::string("Impossible to add state "
						  "[+ (get "state") +]"));
			}
			states_[[+ fsm-name +]_[+ (get "state") +]] = new ::[+
						      (get "state") +]_i; [+
			ENDFOR state +][+ ENDFOR states +]
			[+ FOR virtual-states +][+ FOR state +]
			if (!addState("[+ (get "state") +]")) {
				throw(std::string("Impossible to add state "
						  "[+ (get "state") +]"));
			}
			states_[[+ fsm-name +]_[+ (get "state") +]] = new ::[+
						      (get "state") +]_i; [+
			ENDFOR state +][+ ENDFOR virtual-states +]

			//Only to check FSM integrity
			[+ FOR events +][+ FOR event +]
			if (!addEvent("[+ (get "event") +]")) {
				throw(std::string("Impossible to add event "
						  "[+ (get "event") +]"));
			}[+ ENDFOR event +][+ ENDFOR events +]
			[+ FOR root-events +][+ FOR event +]
			if (!addEvent("[+ (get "event") +]")) {
				throw(std::string("Impossible to add event "
						  "[+ (get "event") +]"));
			}[+ ENDFOR event +][+ ENDFOR root-events +]

			if (!endModify()) {
				throw(std::string("Impossible to fini FSM"));
			}
		}

		Fsm::~Fsm(void)
		{
			startModify(); //useless ... just for check
			std::map<states_t, State *>::iterator it;
			for (it = states_.begin(); it != states_.end(); it++) {
				State * tmp;
				tmp = (*it).second;
				if (tmp) {
					// check and print error if needed
					remState(tmp->name());
					dbg(std::string("Deleting state: ") +
					    tmp->name());
					delete tmp;
				}
			}
			endModify(); //useless ... just for check
		}

		std::ostream& operator<<(std::ostream& s, const Fsm& f)
		{
			s << std::endl << "###### FSM [" << f.name_
			  << "] DUMP ### START ######" << std::endl;
			s << f.nextState_;
			s << "###### FSM [" << f.name_
			  << "] DUMP ###  END  ######" << std::endl
			  << std::endl;
			return s;
		}

		[+ FOR events +][+ FOR event +]
		bool Fsm::[+ (get "event") +](void * context)
		{
			State * tmp;
			tmp = currentState();
			if (!tmp) {
				throw(std::string("Invalid current state!"));
				//return false;
			}
			dbg("Event: [+ (get "event") +]");

			if (!tmp->[+ (get "event") +](context)) {
				err("Error in event '[+ (get "event") +]' ... "
				    "maintaining the old state '"
				    + tmp->name() + "'");
				return false;
			}

			prevState_    = currentState_;
			currentState_ = nextState_[currentState_][[+
					   fsm-name +]_[+ (get "event") +]];
			dbg(std::string("New state: ") +
			    STATE_NAME(currentState_));

			tmp = currentState();
			if (!tmp) {
				throw(std::string("Invalid next state!"));
			}

			switch (prevState_) {[+
			       FOR transitions +] [+ FOR transition +][+
				 IF (== (get "event") (get "on-event")) +][+
				   FOR states +][+ FOR state +][+
				    IF (== (get "from-state") (get "state")) +]
				case ([+ fsm-name +]_[+ (get "state") +]) : {
					tmp->after_[+ (get "on-event") +]_from_[+(get "from-state")+](context);
					break;
				}[+ ENDIF +][+
				   ENDFOR state +][+ ENDFOR states +][+
				   FOR virtual-states +][+ FOR state +][+
				    IF (== (get "from-state") (get "state")) +]
				case ([+ fsm-name +]_[+ (get "state") +]) : {
					tmp->after_[+ (get "on-event") +]_from_[+(get "from-state")+](context);
					break;
				}[+ ENDIF +][+
				   ENDFOR state +][+ ENDFOR virtual-states +][+
				 ENDIF +][+
			       ENDFOR transition +][+ ENDFOR transitions +]
				default: {
					dbg(std::string("No after_[+ (get "event") +]_from_") +
					    STATE_NAME(prevState_));
					break;
				}
			}

			return true;
		}
		[+ ENDFOR event +][+ ENDFOR events +]

		[+ FOR root-events +][+ FOR event +]
		nextEvFor_[+ (get "event") +]_t Fsm::[+ (get "event") +](void * context)
		{
			State * tmp;
			tmp = currentState();
			if (!tmp) {
				throw(std::string("Invalid current state!"));
				//return false;
			}
			dbg("Event: [+ (get "event") +]");

			nextEvFor_[+ (get "event") +]_t next_ev;
			next_ev = tmp->[+ (get "event") +](context);

			if (!next_ev) {
				err("Error in event '[+ (get "event") +]' ... "
				    "maintaining the old state '"
				    + tmp->name() + "'");
				return next_ev;
			}

			prevState_    = currentState_;
			currentState_ = nextState_[currentState_][[+
					   fsm-name +]_[+ (get "event") +]];
			dbg(std::string("New state: ") +
			    STATE_NAME(currentState_));

			tmp = currentState();
			if (!tmp) {
				throw(std::string("Invalid next state!"));
			}

			switch (prevState_) {[+
			       FOR transitions +] [+ FOR transition +][+
				 IF (== (get "event") (get "on-event")) +][+
				   FOR states +][+ FOR state +][+
				    IF (== (get "from-state") (get "state")) +]
				case ([+ fsm-name +]_[+ (get "state") +]) : {
					tmp->after_[+ (get "on-event") +]_from_[+(get "from-state")+](context);
					break;
				}[+ ENDIF +][+
				   ENDFOR state +][+ ENDFOR states +][+
				   FOR virtual-states +][+ FOR state +][+
				    IF (== (get "from-state") (get "state")) +]
				case ([+ fsm-name +]_[+ (get "state") +]) : {
					tmp->after_[+ (get "on-event") +]_from_[+(get "from-state")+](context);
					break;
				}[+ ENDIF +][+
				   ENDFOR state +][+ ENDFOR virtual-states +][+
				 ENDIF +][+
			       ENDFOR transition +][+ ENDFOR transitions +]
				default: {
					dbg(std::string("No after_[+ (get "event") +]_from_") +
					    STATE_NAME(prevState_));
					break;
				}
			}

			return next_ev;
		}
		[+ ENDFOR event +][+ ENDFOR root-events +]

		State * Fsm::currentState(void)
		{
			std::map<states_t, State *>::iterator it;
			it = states_.find(currentState_);
			if (it == states_.end()) {
				err(std::string("Invalid pointer for "
						"current state!"));
				return 0;
			}
			std::string name = (*it).second ?
				(*it).second->name() : "Invalid pointer";
			dbg("Current state: " + name);
			return (*it).second;
		}

		bool Fsm::go2prevState(void)
		{
			if (prevState_ == currentState_) {
				err("Previous and current state are equal!"
				    " ... only 1 step back is allowed");
				return false;
			}

			currentState_ = prevState_;

			std::string name = STATE_NAME(currentState_);
			dbg("Setting FSM state to previous one: " + name);

			return true;
		}

		std::ostream& operator<<(std::ostream& s,
					 const fsm::base_[+ fsm-name +]::
					 Fsm::states_t& st)
		{
			s << STATE_NAME(st);
			return s;
		}

		std::ostream& operator<<(std::ostream& s,
					 const fsm::base_[+ fsm-name +]::
					 Fsm::events_t& ev)
		{
			s << EVENT_NAME(ev);
			return s;
		}
	}
	[+ ENDFOR +]


	/*************************************/
	/*   Finite State Machine - Wrapper  */
	/*************************************/
	[+ FOR fsm +]
	[+ DEFINE fsm-name +][+ (get "name") +][+ ENDDEF +]
	namespace [+ fsm-name +] {

		//
		// virtFsm
		//
		virtFsm::virtFsm(base_[+ fsm-name +]::BaseFSM::traceLevel_t level)
			throw(std::string)
		{
			try {
				fsm_ = new base_[+ fsm-name +]::Fsm(level);
				assert(fsm_);
			} catch (std::string e) {
				throw(e);
			} catch (...) {
				throw(std::string("Impossible to start virtFSM"));
			}
		}

		virtFsm::~virtFsm(void)
		{
			if (fsm_) delete fsm_;
		}

		std::ostream& operator<<(std::ostream& s, const virtFsm& f)
		{
			s << std::endl << "###### virtFSM [" //<< f.name_
			  << "] DUMP ### START ######" << std::endl;
			//s << f.nextState_;
			s << "###### FSM [" //<< f.name_
			  << "] DUMP ###  END  ######" << std::endl
			  << std::endl;
			return s;
		}

		void virtFsm::post(root_events_t ev, void * context, bool enqueue)
		{
			data_event_t * data;
			data = new data_event_t;
			if (!data) {
				std::cout << "ERR: Cannot allocate memory for "
					"a new data event struct" << std::endl;
				return;
			}
			data->ev      = ev;
			data->context = context;

			events_.push_back(data);

			if (!enqueue) {
				runPendingWork();
			}
		}

		void virtFsm::runPendingWork(void)
		{
			if (events_.empty()) {
				std::cout << "[DBG]: Empty event list ... "
					"nothing else to do" << std::endl;
				return;
			}

			data_event_t * data;
			data = events_.front();
			events_.pop_front();

			if (!data) {
				std::cout << "ERR: Invalid data event from "
					"event list" << std::endl;
				return;
			}

			switch (data->ev) {
				[+ FOR root-events +][+ FOR event +]
				case [+ fsm-name +]_[+ (get "event") +]:
					[+ (get "event") +](data->context);
					break;
				[+ ENDFOR event +][+ ENDFOR root-events +]
				//case [+ fsm-name +]_invalid_event:
				default:
					std::cout << "ERR: Invalid event type"
						  << std::endl;
			}

			delete data;

			runPendingWork();
		}

		[+ FOR event-hierarchy +][+ FOR relationship +]
		void virtFsm::[+ (get "root-event") +](void * context)
		{
			// case sul tipo di next_event e se errore
			//  torno stato precedente

			fsm::base_[+ fsm-name +]::nextEvFor_[+ (get "root-event") +]_t next_ev;
			try {
				next_ev = fsm_->[+ (get "root-event") +](context);
			} catch (std::string e) {
				std::cout << "EXCEPTION: " << e << std::endl;
				return;
			} catch (...) {
				std::cout << "UNKNOWN EXCEPTION" << std::endl;
				return;
			}

			bool res;
			switch (next_ev) { [+ FOR event +]
				case fsm::base_[+ fsm-name +]::[+ fsm-name
				     +]_from_[+ (get "root-event") +]_to_[+
				     (get "event") +]:
					try {
						res = fsm_->[+(get "event")+](context);
					} catch (std::string e) {
						std::cout << "EXCEPTION: " << e << std::endl;
						fsm_->go2prevState();
						return;
					} catch (...) {
						std::cout << "UNKNOWN EXCEPTION" << std::endl;
						fsm_->go2prevState();
						return;
					}
					break;
				[+ ENDFOR event +]
				case fsm::base_[+ fsm-name +]::[+ fsm-name
					     +]_from_[+ (get "root-event")
					     +]_to_InvalidEvent:
				default:
					std::cout << "ERR: Invalid event type"
						  << std::endl;
					fsm_->go2prevState();
					return;
			}
			if (!res) {
				std::cout << "ERR: First step for "
					  << __FUNCTION__ <<" failed"
					  << std::endl;
				fsm_->go2prevState();
			}
		}
		[+ ENDFOR relationship +][+ ENDFOR event-hierarchy +]

		std::string virtFsm::currentState(void) {
			return fsm_->currentState() ?
				fsm_->currentState()->name(): "Unknown";
		}

		//std::ostream& operator<<(std::ostream& s,
		//			 const fsm::virtual_RSVP::
		//			 virtFsm::states_t& st)
		//{
		//	s << STATE_NAME(st);
		//	return s;
		//}
		//
		//std::ostream& operator<<(std::ostream& s,
		//			 const fsm::virtual_RSVP::
		//			 virtFsm::events_t& ev)
		//{
		//	s << EVENT_NAME(ev);
		//	return s;
		//}
	}
	[+ ENDFOR +]
}
[+ ESAC +]
