/*
 *  This file is part of phosphorus-g2mpls.
 *
 *  Copyright (C) 2006, 2007, 2008, 2009 Nextworks s.r.l.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Authors:
 *
 *  Giacomo Bernini       (Nextworks s.r.l.) <g.bernini_at_nextworks.it>
 *  Gino Carrozzo         (Nextworks s.r.l.) <g.carrozzo_at_nextworks.it>
 *  Nicola Ciulli         (Nextworks s.r.l.) <n.ciulli_at_nextworks.it>
 *  Giodi Giorgi          (Nextworks s.r.l.) <g.giorgi_at_nextworks.it>
 *  Francesco Salvestrini (Nextworks s.r.l.) <f.salvestrini_at_nextworks.it>
 */



#include "thread.h"
#include "linklist.h"


#ifndef _ZEBRA_XXXD_H
#define _ZEBRA_XXXD_H

#define XXXD_DEFAULT_CONFIG "/usr/local/etc/xxxd.conf"
/* this will be the name of the config file in the zebra
 *  config directory (could be /usr/local/etc/)
 */

//#define PATH_XXXD_PID "/usr/local/quagga-0.99.7/etc/xxxd.pid"

#define XXXD_VTY_PORT 2609
/* telnet to this port to login to the xxxd vty */

//#define XXX_VTYSH_PATH "/var/run/xxxd.vty"
/* name of the unix socket to communicate with the vtysh
 */

/* XXX  master for system wide configuration and variables. */
struct xxx_master {
	/* XXX thread master. */
	struct thread_master *master;

	/* Zebra interface list. */
	struct zlist *iflist;

	/* Redistributed external information. */
	struct route_table *external_info[ZEBRA_ROUTE_MAX + 1];
#define EXTERNAL_INFO(T)      xxx_m->external_info[T]

	/* XXX start time. */
	time_t start_time;

};

/* XXX instance structure. */
struct xxx
{
	/* XXX Router ID. */
	struct in_addr router_id;		/* Configured automatically. */
	struct in_addr router_id_static;	/* Configured manually. */
	
	struct zlist *xiflist;                   /* xxx interfaces */
	u_char passive_interface_default;	/* passive-interface default */
};

/* Extern variables. */
extern struct xxx_master *xxx_m;
extern struct thread_master *master;


/* Prototypes. */
extern void xxx_vty_init (void);
extern void xxx_if_init (void);
extern void xxx_init (void);
extern void xxx_master_init (void);


#endif /* _ZEBRA_XXXD_H */


